unit uBachet;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    eA: TEdit;
    lA: TLabel;
    eB: TEdit;
    lB: TLabel;
    bBerechne: TButton;
    mAusgabe: TMemo;
    bLoesche: TButton;
    procedure bBerechneClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bBerechneClick(Sender: TObject);
var
  a,b,g,x,y : integer;
  s         : string;

  // DIFF CM1 Algorithmen der elementaren Zahlentheorie, S.32
  procedure Bachet(a,b : integer; var g,x,y : integer);
  var
    bg,bu,cg,cu,xg,xu,yg,yu : integer;
  begin
    bg := a; cg := 0; xg := 1; yg := 0;
    bu := b; cu := a div b; xu := 0; yu := 1;
    while (bg <> 0) and (bu <>0) do
    begin
      xg := xg-cu*xu; yg := yg-cu*yu; bg := bg mod bu;
      if bg = 0
      then
      begin
        g := bu; x := xu; y := yu;
      end
      else
      begin
        cg := bu div bg; xu := xu-cg*xg;
        yu := yu-cg*yg; bu := bu mod bg;
      end;
      if bu = 0
      then
      begin
        g := bg; x := xg; y := yg;
      end
      else
        cu := bg div bu;
    end;
  end;

begin
  a := StrToInt(eA.text); b := StrToInt(eB.text);

  Bachet(a,b,g,x,y);

  s := IntToStr(g)+' = '+IntToStr(x)+'*'+IntToStr(a)+' + '+
                         IntToStr(y)+'*'+IntToStr(b);
  mAusgabe.Lines.Add(s);
end;

procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mAusgabe.Clear;
end;

end.
